using System;
using System.Linq;
using System.Xml;
using Aitex.Core.RT.Device;
using Aitex.Core.RT.IOCore;
using Aitex.Core.RT.Log;
using Aitex.Core.Util;
using MECF.Framework.Common.IOCore;
using MECF.Framework.Common.PLC;
using MECF.Framework.RT.Core.IoProviders;

namespace SicModules.Devices
{
    public class SiemensIoProvider : IoProvider
    {


        private IAdsPlc _ads;
        private static object _locker = new object();

        private R_TRIG _trigConnected = new R_TRIG();

        protected override void SetParameter(XmlElement nodeParameter)
        {

        }


        private bool MonitorAdsConnection()
        {

            //if (_SiemensClient == null)
            //{
            //    _SiemensClient = DEVICE.GetDevice<PMModule>(Module + "." + Module)?.Siemens;
            //}
            //if (_SiemensClient != null) return _SiemensClient.IsTrue;
            //return false;

            if (_ads == null)
            {
                _ads = DEVICE.GetOptionDevice($"{Module}.MainPLC", typeof(SicAds)) as IAdsPlc;
            }

            return _ads != null && _ads.CheckIsConnected();
        }

        //public bool IsCommunicationError
        //{
        //    get { return _ads.IsCommunicationError; }
        //}
        protected override void Close()
        {

        }
        protected override void Open()
        {

        }

        protected override bool OnTimer()
        {
            _trigConnected.CLK = MonitorAdsConnection();

            if (!_trigConnected.M)
                return true;

            lock (_locker)
            {
                // PLC数据以32位二级制存储，软件读取的值与DINT相同
                // 如果是DINT类型数据，直接使用，无需转换；
                // 如果是REAL类型数据，先使用BitConverter.GetBytes获取有4个元素的字节数组，再使用BitConverter.ToSingle，得到float类型值；
                // 如果是DWORD类型数据，先使用BitConverter.GetBytes获取有4个元素的字节数组，再进行位运算，得到每位的值

                //int[] input = ReadInput();
                //Console.WriteLine(input[0]);
                //byte[] byteArr = BitConverter.GetBytes(input[0]);
                //float fValve = BitConverter.ToSingle(byteArr, 0);

                foreach (var blockIndex in DiVariables.Keys)
                {
                    var ioVar = DiVariables[blockIndex];
                    var diData = ReadDIn(ioVar.Name, (ushort)ioVar.Length);
                    if (diData != null)
                    {
                        var diBuffer = ParseDI(blockIndex, diData);
                        if (diBuffer != null)
                        {
                            _buffer.SetDiBuffer(_source, ioVar.Block.Index, diBuffer);
                        }
                    }
                }


                foreach (var blockIndex in DoVariables.Keys)
                {
                    var ioVar = DoVariables[blockIndex];
                    var doData = ReadDOut(ioVar.Name, (ushort)ioVar.Length);
                    if (doData != null)
                    {
                        var doBuffer = ParseDO(blockIndex, doData);
                        if (doBuffer != null)
                        {
                            _buffer.SetDoBuffer(_source, ioVar.Block.Index, doBuffer);
                        }
                    }
                }


                foreach (var blockIndex in AiVariables.Keys)
                {
                    var ioVar = AiVariables[blockIndex];
                    var aiData = ReadAIn(ioVar.Name, (ushort)ioVar.Length);
                    if (aiData != null)
                    {
                        var aiBuffer = ParseAI(blockIndex, aiData);
                        if (aiBuffer != null)
                        {
                            _buffer.SetAiBuffer(_source, ioVar.Block.Index, aiBuffer);
                        }
                    }
                }

                foreach (var blockIndex in AoVariables.Keys)
                {
                    var ioVar = AoVariables[blockIndex];
                    var aoData = ReadAOut(ioVar.Name, (ushort)ioVar.Length);
                    if (aoData != null)
                    {
                        var aoBuffer = ParseAO(blockIndex, aoData);
                        if (aoBuffer != null)
                        {
                            _buffer.SetAoBuffer(_source, ioVar.Block.Index, aoBuffer);
                        }
                    }
                }

            }

            return true;
        }
        private bool CommunicationError()
        {
            //_buffer.SetDiBuffer(_source, 0, new bool[1000]);
            //_buffer.SetDoBuffer(_source, 0, new bool[1000]);
            //_buffer.SetAiBufferFloat(_source, 0, new float[500]);
            //_buffer.SetAoBufferFloat(_source, 0, new float[500]);

            return true;
        }
        protected byte[] ReadDIn(string variable, ushort len)
        {
            if (!_trigConnected.M)
                return null;

            if (_ads.BulkReadRenderResult(variable, len, out var data))
                return data;

            return null;
        }
        private byte[] ReadDOut(string variable, ushort len)
        {
            if (!_trigConnected.M)
                return null;

            if (_ads.BulkReadRenderResult(variable, len, out var data))
                return (byte[])data;

            return null;
        }

        protected byte[] ReadAIn(string variable, ushort len)
        {
            if (!_trigConnected.M)
                return null;

            if (_ads.BulkReadRenderResult(variable, len, out var data))
                return data;

            return null;
        }
        private byte[] ReadAOut(string variable, ushort len)
        {
            if (!_trigConnected.M)
                return null;

            if (_ads.BulkReadRenderResult(variable, len, out var data))
                return (byte[])data;

            return null;
        }

        private bool[] ParseDI(int blockIndex, byte[] inputValue)
        {
            var diList = Singleton<IoManager>.Instance.GetDIList($"{Module}.io").Where(x => x.BlockIndex == blockIndex);

            var result = new bool[1000];
            foreach (var diAccessor in diList)
            {
                var addr = diAccessor.Addr;
                var index = int.Parse(addr);
                var Offset = index % 8;
                var val = index % 8 == 0 ? index / 8 : (index - index % 8) / 8;
                result[diAccessor.BlockOffset] = ((inputValue[val] >> Offset) & 0x1) == 1;
            }
            return result;
        }


        private bool[] ParseDO(int blockIndex, byte[] outputValue)
        {
            //Addr="OUTPUT[0].4"
            var doList = Singleton<IoManager>.Instance.GetDOList($"{Module}.io").Where(x => x.BlockIndex == blockIndex);

            var cache = new bool[1000];
            foreach (var doAccessor in doList)
            {
                var addr = doAccessor.Addr;
                var index = int.Parse(addr);
                var whichBit = index % 8;
                var whichByte = index % 8 == 0 ? index / 8 : (index - index % 8) / 8;

                cache[doAccessor.BlockOffset] = ((outputValue[whichByte] >> whichBit) & 0x1) == 1;
            }
            return cache;
        }


        private float[] ParseAI(int blockIndex, byte[] inputValue)
        {
            var aiList = Singleton<IoManager>.Instance.GetAIList($"{Module}.io").Where(x => x.BlockIndex == blockIndex);
            var result = new float[500];
            foreach (var aiAccessor in aiList)
            {
                var addr = aiAccessor.Addr;
                var index = int.Parse(addr);
                var valve = BitConverter.ToSingle(new byte[] { inputValue[index * 4 + 3], inputValue[index * 4 + 2], inputValue[index * 4 + 1], inputValue[index * 4] }, 0);
                result[aiAccessor.BlockOffset] = valve;
            }
            return result;
        }


        private float[] ParseAO(int blockIndex, byte[] outputValue)
        {
            //Addr="OUTPUT[30]"
            var aoList = Singleton<IoManager>.Instance.GetAOList($"{Module}.io").Where(x => x.BlockIndex == blockIndex);

            var result = new float[500];
            foreach (var aoAccessor in aoList)
            {
                var addr = aoAccessor.Addr;
                var index = int.Parse(addr);
                var valve = BitConverter.ToSingle(new[]
                    {
                        outputValue[index * 4 + 3],
                        outputValue[index * 4 + 2],
                        outputValue[index * 4 + 1],
                        outputValue[index * 4]
                    },
                    0);
                result[aoAccessor.BlockOffset] = valve;
            }

            return result;
        }
        protected override short[] ReadAi(int offset, int size)
        {
            throw new NotImplementedException();
        }

        protected override bool[] ReadDi(int offset, int size)
        {
            throw new NotImplementedException();
        }



        protected override void WriteAo(int offset, short[] buffer)
        {
            throw new NotImplementedException();
        }

        protected override void ReadDo(int offset, bool[] buffer)
        {
            throw new NotImplementedException();
        }

        protected override short[] ReadAo(int offset, int size)
        {
            throw new NotImplementedException();
        }

        protected override void WriteDo(int offset, bool[] buffer)
        {
            throw new NotImplementedException();
        }


        public override bool SetValue(AOAccessor aoItem, float value)
        {
            if (!_trigConnected.M)
                return false;

            var ioVar = AoVariables[aoItem.BlockIndex];

            //// 获取下标，转换成16进制 IEEE 754浮点数，然后整个写下去
            var addr = aoItem.Addr;
            var index = int.Parse(addr);
            var address = ioVar.Name.Substring(0, 9) + (int.Parse(ioVar.Name.Substring(9, 3)) + index * 4);
            var data = new byte[4];

            if (index <= 48)
            {
                data = BitConverter.GetBytes(value);
            }
            else if (index >= 49)
            {
                data = BitConverter.GetBytes((int)value);
            }

            Array.Reverse(data);

            return _ads.BulkWriteByteRenderResult(address, data);
        }

        public override bool SetValue(DOAccessor doItem, bool value)
        {
            if (!_trigConnected.M)
            {
                return false;
            }

            if (!IO.CanSetDO(doItem.Name, value, out var reason))
            {
                LOG.Write(reason);
                return false;
            }

            lock (_locker)
            {
                var ioVar = DoVariables[doItem.BlockIndex];

                ////获取单个DWORD数据，修改其中一位，然后整个Byte写下去
                var addr = doItem.Addr;
                var add = int.Parse(addr);
                var indexByte = add % 8;
                var index = add % 8 == 0 ? add / 8 : (add - add % 8) / 8;
                var val = 1 << indexByte;
                var output = ReadDOut(ioVar.Name, (ushort)ioVar.Length);
                if (output == null)
                {
                    LOG.Write("ReadDOut = null , in SetValue()");
                    return false;
                }

                output[index] = value
                    ? Convert.ToByte(Convert.ToUInt16(output[index]) | val)
                    : Convert.ToByte((Convert.ToUInt16(output[index]) & ~val));

                var stringSeparators = new string[] { "DBB" };
                var result = ioVar.Name.Split(stringSeparators, StringSplitOptions.None);
                int.TryParse(result[1], out var startIndex);
                var finalIndex = startIndex + index;
                var address = $"{result[0]}DBB{finalIndex}";
                var data = new byte[] { output[index] };

                return _ads.BulkWriteByteRenderResult(address, data);
            }
        }
    }
}
